<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>Assignment #6 Answers</title>
</head>
<body>
<H1>Assignment #6 Answers</H1>





<B>Introductory C Programming
<br>
<br>
UW Experimental College
<br>
<br>
Assignment #6 ANSWERS
</B><br>
<br>
<p>Question 1.
<I>If we say
<TT>int i = 5;
int *ip = &amp;i;
</TT>then what is <TT>ip</TT>?
What is its value?
</I><p><TT>ip</TT> is a variable which can point to an <TT>int</TT>
(that is, its value will be a pointer to an <TT>int</TT>;
or informally, we say that <TT>ip</TT> <em>is</em>
``a pointer to an <TT>int</TT>'').
Its value is a pointer which points to the variable <TT>i</TT>.
<p>Question 2.
<I>If ip is a pointer to an int, what does <TT>ip++</TT> mean?
What does
<TT>*ip++ = 0</TT>
do?
</I><p><TT>ip++</TT> means about the same as it does for any other variable:
increment it by 1,
that is,
as if we had written <TT>ip = ip + 1</TT>.
In
the case of a pointer,
this means to
make it point to the object (the <TT>int</TT>)
one past the one it used to.
<TT>*ip++ = 0</TT> sets the <TT>int</TT> variable pointed to 
by <TT>ip</TT> to 0,
and then increments <TT>ip</TT>
to point to the next <TT>int</TT>.
<p>Question 3.
<I>How much memory does the call <TT>malloc(10)</TT> allocate?
What if you want enough memory for 10 <TT>int</TT>s?
</I><p><TT>malloc(10)</TT> allocates 10 bytes,
which is
enough space for 10 <TT>char</TT>s.
To allocate space for 10 <TT>int</TT>s,
you could call <TT>malloc(10 * sizeof(int))</TT>
.
<p>Question 4.
<I>If <TT>char</TT> and <TT>int</TT> pointers are different,
how is it possible to write
</I><pre>
	char *cp = malloc(10);
	int *ip = malloc(sizeof(int));
</pre>
<I>without error on either line?
</I><p><TT>malloc</TT> is declared as returning the special,
``generic'' pointer type <TT>void *</TT>,
which can be
(and is)
automatically converted to different pointer types,
as needed.
<p>Exercise 1.
<I>Write a program to read lines
and print only those containing a certain word.
</I><br>
<br>
<pre>
#include &lt;stdio.h&gt;
#include &lt;string.h&gt;

extern int getline(char [], int);

int main()
{
	char line[100];
	char *pat = "hello";

	while(getline(line, 100) != EOF)
		{
		if(strstr(line, pat) != NULL)
			printf("%s\n", line);
		}

	return 0;
}</pre>
<p>Exercise 2.
<I>Rewrite the checkbook-balancing program
to use the <TT>getwords</TT> function
to make it easy to take the word ``check'' or ``deposit'',
and the amount, from a single line.
</I><br>
<br>
<pre>
#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;	/* for atof() */

#define MAXLINE 100
#define MAXWORDS 10

extern int getline(char [], int);
extern int getwords(char *, char *[], int);

int main()
{
	double balance = 0.0;
	char line[MAXLINE];
	char *words[MAXWORDS];
	int nwords;

	while (getline(line, MAXLINE) &gt; 0)
		{
		nwords = getwords(line, words, MAXWORDS);

		if(nwords == 0)	/* blank line */
			continue;

		if(strcmp(words[0], "deposit") == 0)
			{
			if(nwords &lt; 2)
				{
				printf("missing amount\n");
				continue;
				}
			balance += atof(words[1]);
			}
		else if(strcmp(words[0], "check") == 0)
			{
			if(nwords &lt; 2)
				{
				printf("missing amount\n");
				continue;
				}
			balance -= atof(words[1]);
			}
		else	{
			printf("bad data line: \"%s\"\n", words[0]);
			continue;
			}

		printf("balance: %.2f\n", balance);
		}
	
	return 0;
}</pre>
<p>Exercise 3.
<I>Rewrite the line-reversing function to use pointers.
</I><p>Here is one way:
<pre>
int reverse(char *string)
{
	char *lp = string;			/* left pointer */
	char *rp = &amp;string[strlen(string)-1];	/* right pointer */
	char tmp;
	while(lp &lt; rp)
		{
		tmp = *lp;
		*lp = *rp;
		*rp = tmp;
		lp++;
		rp--;
		}
	return 0;
}
</pre>
<p>Exercise 4.
<I>Rewrite the character-counting function to use pointers.
</I><br>
<br>
<pre>
int countnchars(char *string, int ch)
{
	char *p;
	int count = 0;
	for(p = string; *p != '\0'; p++)
		{
		if(*p == ch)
			count++;
		}
	return count;
}
</pre>
<p>Exercise 5.
<I>Rewrite the string concatenation program
to call <TT>malloc</TT> to allocate memory
for the concatenated result.
</I><p><pre>
#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;	/* for malloc */
#include &lt;string.h&gt;	/* for strcpy and strcat */

#define MAXLINE 100

extern int getline(char [], int);

int main()
{
	char string1[MAXLINE], string2[MAXLINE];
	int len1, len2;
	char *newstring;

	printf("enter first string:\n");
	len1 = getline(string1, 100);
	printf("enter second string:\n");
	len2 = getline(string2, 100);

	if(len1 == EOF || len2 == EOF)
		exit(1);

	newstring = malloc(len1 + len2 + 1);	/* +1 for \0 */

	if(newstring == NULL)
		{
		printf("out of memory\n");
		exit(1);
		}

	strcpy(newstring, string1);
	strcat(newstring, string2);

	printf("%s\n", newstring);

	return 0;
}</pre>
<p>Exercise 6.
<I>Rewrite the string-replacing function to use pointers.
</I><p>Here is one way:
<pre>
void replace(char string[], char *from, char *to)
{
	char *start, *p1, *p2;
	for(start = string; *start != '\0'; start++)
		{
		p1 = from;
		p2 = start;
		while(*p1 != '\0')
			{
			if(*p1 != *p2)
				break;
			p1++;
			p2++;
			}
		if(*p1 == '\0')
			{
			for(p1 = to; *p1 != '\0'; p1++)
				*start++ = *p1;
			return;
			}
		}
}
</pre>
The bulk of this code is a copy of
the <TT>mystrstr</TT> 
function
in the notes, chapter 10, section 10.4, p. 8.
(Since <TT>strstr</TT>'s job is to find one string within 
another, it's a natural for the first half of <TT>replace</TT>.)
We could also call <TT>strstr</TT> directly, simplifying <TT>replace</TT>:
<pre>
#include &lt;string.h&gt;

void replace(char string[], char *from, char *to)
{
	char *p1;
	char *start = strstr(string, from);
	if(start != NULL)
		{
		for(p1 = to; *p1 != '\0'; p1++)
			*start++ = *p1;
		return;
		}
}
</pre>
Again,
we might wonder about the case when the string to be 
edited contains multiple occurrences of the <TT>from</TT> string,
and ask whether <TT>replace</TT> should replace the first one,
or all of them.
The problem statement didn't make this detail clear.
Our first
two implementations have
replaced only the first occurrence.
It happens, though, that it's trivial to rewrite our first version
to make it replace all occurrences--just omit the 
<TT>return</TT> after the first string has been replaced:
<pre>
void replace(char string[], char *from, char *to)
{
	char *start, *p1, *p2;
	for(start = string; *start != '\0'; start++)
		{
		p1 = from;
		p2 = start;
		while(*p1 != '\0')
			{
			if(*p1 != *p2)
				break;
			p1++;
			p2++;
			}
		if(*p1 == '\0')
			{
			for(p1 = to; *p1 != '\0'; p1++)
				*start++ = *p1;
			}
		}
}
</pre>
Rewriting the second version wouldn't be much harder.
<p>Exercise 7.
<I>Write a program to read lines of text up to EOF,
and then print them out in reverse order.
</I><p>One of the reasons this program is harder
is that it uses pointers to pointers.
When we used pointers to simulate an array of integers,
we used pointers to integers.
In this program, we want to simulate an array of strings,
or an array of pointers to characters.
Therefore, we use <em>pointers</em> to pointers to characters,
or <TT>char **</TT>.
<pre>
#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;

extern int getline(char [], int);

#define MAXLINE 100

int main()
{
int i;
char line[MAXLINE];
char **lines;
int nalloc, nitems;

nalloc = 10;
lines = malloc(nalloc * sizeof(char *));
if(lines == NULL)
	{
	printf("out of memory\n");
	exit(1);
	}

nitems = 0;

while(getline(line, MAXLINE) != EOF)
	{
	if(nitems &gt;= nalloc)
		{
		char **newp;
		nalloc += 10;
		newp = realloc(lines, nalloc * sizeof(char *));
		if(newp == NULL)
			{
			printf("out of memory\n");
			exit(1);
			}
		lines = newp;
		}

	lines[nitems] = malloc(strlen(line) + 1);
	strcpy(lines[nitems], line);
	nitems++;
	}

for(i = nitems - 1; i &gt;= 0; i--)
	printf("%s\n", lines[i]);

return 0;
}
</pre>
Notice that for each line we read,
we call <TT>malloc</TT> to allocate space for a copy of it,
and then use <TT>strcpy</TT> to make the copy.
We could not simply set
<pre>
	lines[nitems++] = line;
</pre>
each time,
because <TT>line</TT> is a single array,
which can only hold one line,
and it gets overwritten with the contents of each input line.
(In other words,
if we didn't call <TT>malloc</TT> and make a copy,
we'd end up at the end with only the last line.
You might try it to see what happens.)
<p><I>Extra credit:
remove the restriction imposed by the fixed-size array;
allow the program to accept
arbitrarily-long lines.
</I><p>First we will write another version of <TT>getline</TT>,
called <TT>mgetline</TT>.
<TT>mgetline</TT> calls <TT>malloc</TT> and <TT>realloc</TT>
to get enough memory for the line it's currently reading,
regardless of how long that line is.
<TT>mgetline</TT> returns a pointer to the allocated memory;
therefore,
the caller does not have to pass an array for 
<TT>mgetline</TT> to read into.
(It will be the caller's responsibility to <TT>free</TT> the 
memory when it doesn't need the line of text any more.)
<pre>
#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;

char *mgetline()
{
char *line;
int nalloc = 10;
int nch = 0;
int c;

line = malloc(nalloc + 1);
if(line == NULL)
	{
	printf("out of memory\n");
	exit(1);
	}

while((c = getchar()) != EOF)
	{
	if(c == '\n')
		break;

	if(nch &gt;= nalloc)
		{
		char *newp;
		nalloc += 10;
		newp = realloc(line, nalloc + 1);
		if(newp == NULL)
			{
			printf("out of memory\n");
			exit(1);
			}
		line = newp;
		}
	line[nch++] = c;
	}

if(c == EOF &amp;&amp; nch == 0)
	{
	free(line);
	return NULL;
	}

line[nch] = '\0';

return line;
}
</pre>
Now we can rewrite the line-reversing program to call <TT>mgetline</TT>.
Note that we no longer need the local <TT>line</TT> array.
Instead, we use a pointer, <TT>linep</TT>,
which holds the return value from <TT>mgetline</TT>.
Since <TT>mgetline</TT> returns a new pointer to a new block 
of memory each time we call it,
in this program
(unlike the previous one)
we <em>can</em> set
<pre>
	lines[nitems++] = linep;
</pre>
without overwriting anything.
<pre>
#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;

extern char *mgetline();

int main()
{
int i;
char *linep;
char **lines;
int nalloc, nitems;

nalloc = 10;
lines = malloc(nalloc * sizeof(char *));
if(lines == NULL)
	{
	printf("out of memory\n");
	exit(1);
	}

nitems = 0;

while((linep = mgetline()) != NULL)
	{
	if(nitems &gt;= nalloc)
		{
		char **newp;
		nalloc += 10;
		newp = realloc(lines, nalloc * sizeof(char *));
		if(newp == NULL)
			{
			printf("out of memory\n");
			exit(1);
			}
		lines = newp;
		}

	lines[nitems++] = linep;
	}

for(i = nitems - 1; i &gt;= 0; i--)
	printf("%s\n", lines[i]);

return 0;
}
</pre>
<hr>
<hr>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995-9
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
